/*
** diags.h
*/

/*
** Copyright 1999 by Todd Allen.  All Rights Reserved.  Permission to use,
** copy, modify, distribute, and sell this software and its documentation for
** any purpose is hereby granted without fee, provided that the above
** copyright notice appear in all copies and that both the copyright notice
** and this permission notice appear in supporting documentation.
**
** No representations are made about the suitability of this software for any
** purpose.  It is provided ``as is'' without express or implied warranty,
** including but not limited to the warranties of merchantability, fitness
** for a particular purpose, and noninfringement.  In no event shall Todd
** Allen be liable for any claim, damages, or other liability, whether in
** action of contract, tort, or otherwise, arising from, out of, or in
** connection with this software.
*/

#ifndef __DIAGS_H
#define __DIAGS_H

#include <X11/Intrinsic.h>

extern  String    program;

extern  String    static_format  (String  form,
                                  ...);

extern  void      warning        (String  msg);
extern  void      error          (String  msg);
extern  void      fatal          (String  msg);
extern  void      panic          (String  msg);

extern  void      assertion_fail (int     line,
                                  String  file);

#define assert(cond) \
   do { if (!(cond)) assertion_fail(__LINE__, __FILE__); } while (0)

#endif
