/*
** timemath.h
*/

/*
** Copyright 1999 by Todd Allen.  All Rights Reserved.  Permission to use,
** copy, modify, distribute, and sell this software and its documentation for
** any purpose is hereby granted without fee, provided that the above
** copyright notice appear in all copies and that both the copyright notice
** and this permission notice appear in supporting documentation.
**
** No representations are made about the suitability of this software for any
** purpose.  It is provided ``as is'' without express or implied warranty,
** including but not limited to the warranties of merchantability, fitness
** for a particular purpose, and noninfringement.  In no event shall Todd
** Allen be liable for any claim, damages, or other liability, whether in
** action of contract, tort, or otherwise, arising from, out of, or in
** connection with this software.
*/

#include <sys/time.h>

#ifndef __TIMEMATH_H
#define __TIMEMATH_H

extern  long            difftimevalms     (struct timeval  time1,
                                           struct timeval  time0);
extern  struct timeval  addmstotimeval    (struct timeval  time,
                                           long            ms);
extern  struct timeval  gettime           (void);

#define sametimeval(time1, time0) \
   ((time1).tv_sec == (time0).tv_sec && (time1).tv_usec == (time0).tv_usec)

#define lesstimeval(time1, time0) \
   ((time1).tv_sec < (time0).tv_sec \
    || ((time1).tv_sec == (time0).tv_sec \
        && (time1).tv_usec < (time0).tv_usec))

#endif
